image: docker:latest

services:
  - docker:dind

stages:
  - build
  - publish
  - deploy

variables:
  IMAGE_NAME: product-service

publish_dev:
  stage: publish
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY/$CI_PROJECT_PATH/$IMAGE_NAME:$CI_COMMIT_REF_NAME .
    - docker push $CI_REGISTRY/$CI_PROJECT_PATH/$IMAGE_NAME:$CI_COMMIT_REF_NAME
  only:
    - develop

publish_prod:
  stage: publish
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY/$CI_PROJECT_PATH/$IMAGE_NAME:latest .
    - docker push $CI_REGISTRY/$CI_PROJECT_PATH/$IMAGE_NAME:latest
  only:
    - main

# deploy_dev:
#   stage: deploy
#   image: 
#     name: bitnami/kubectl:latest
#     entrypoint: [""]
#   script:
#     - kubectl rollout restart deployment/frontend-dev
#   only:
#     - develop

# deploy_prod:
#   stage: deploy
#   image: 
#     name: bitnami/kubectl:latest
#     entrypoint: [""]
#   script:
#     - kubectl rollout restart deployment/frontend-prod
#   only:
#     - main